/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SRC_CORE_AI_SPEECH_SERVER_H
#define SRC_CORE_AI_SPEECH_SERVER_H
#include <gio/gio.h>

#include <functional>
#include <mutex>
#include <string>

namespace kyai::core::speech {

using OnConnectionClosed = std::function<void()>;

class CoreAiSpeechServer {
public:
    static CoreAiSpeechServer &getInstance();

    ~CoreAiSpeechServer();

    void init();

    bool available() const { return connection_ != nullptr; }

    GDBusConnection *getConnection() const { return connection_; }

    void setOnConnectionClosed(const OnConnectionClosed &onConnectionClosed) {
        onConnectionClosed_ = onConnectionClosed;
    }

private:
    CoreAiSpeechServer();

    void init(const std::string &unixPath);

    void destroy();

    static void onConnectionClosed(GDBusConnection *connection,
                                   gboolean remotePeerVanished, GError *error,
                                   gpointer userData);

private:
    GDBusConnection *connection_{nullptr};

    gulong handlerId_{};

    OnConnectionClosed onConnectionClosed_;
    mutable std::mutex mutex_;
};

}  // namespace kyai::core::speech

#endif  // SRC_CORE_AI_SPEECH_SERVER_H
